<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:winpixel="http://tilde.town/~lucidiot/winpixel/"
  xsi:schemaLocation="http://tilde.town/~lucidiot/winpixel winpixel.xsd">
  <!-- Generates a shell script that can be used to make some checks about file existence -->
  <xsl:output method="text" />

  <xsl:template match="/">
    <xsl:text><![CDATA[#!/bin/sh
expected_list=$(mktemp)
trap "rm \"$expected_list\"" EXIT
sort >"$expected_list" <<EOF
]]></xsl:text>
    <xsl:apply-templates select="//winpixel:img" />
    <xsl:text><![CDATA[EOF
git ls-files -co '*.bmp' '*.gif' |
git diff --no-index --no-color --no-ext-diff --text -U0 "$expected_list" - |
sed -n '1,/^@@/d;/^[+-]/{s/^-/Image defined in XML but not found in filesystem: /;s/^\+/Image found in filesystem but not in use in XML: /;p}' >&2]]></xsl:text>
  </xsl:template>

  <xsl:template match="winpixel:img">
    <xsl:value-of select="@src" />
    <xsl:text>
</xsl:text>
  </xsl:template>
</xsl:stylesheet>
